/*
 * ce1.c
 */
#include <stdio.h>
#include <string.h>

#define MAX_SIZE  (80 + 1 + 1) /* + +'\0' */
#define WIDTH     80           /*  */


void  center(char [], int);
void  carte(FILE *);
void  cant(char *);


main(int argc, char **argv)
{
    FILE    *fp;

    --argc;
    ++argv;
    if (argc == 0)
        carte(stdin);
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            carte(fp);
            fclose(fp);
            argv++;
        }
    }
    return (0);
}


void  carte(FILE *fp)
{
    char  buf[MAX_SIZE];

    while (fgets(buf, MAX_SIZE, fp) != NULL) {
        center(buf, WIDTH);
        fputs(buf, stdout);
    }
}


/*
 * center() -  ˶򤤤Ĥ뤳Ȥˤäˤ
 *    buf - Ǽΰ (in/out)
 *    w - 
 */
void  center(char buf[], int w)
{
    int   off;
    int   n;
    int   i;

    n = strlen(buf) - 1; /* -1 for '\n' */
    if (w < n)
        return;
    off = (w - n + 1) / 2; /* ٤ο */

    /* ޤˤ餷Ƥ */
    for (i = n + 1; i >= 0; i--)
        buf[i + off] = buf[i];

    /* ˶ */
    while (off--)
        buf[off] = ' ';
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
