/*
 * ce2.c
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX_SIZE  (80 + 1 + 1) /* + +'\0' */
#define WIDTH     80           /*  */
#define ISBLANK(c)      ((c) == ' ' || (c) == '\t')


void  center(char [], int);
void  carte(FILE *);
void  remove_pre_blank(char *);
void  remove_pos_blank(char *);
void  cant(char *);


main(int argc, char **argv)
{
    FILE    *fp;

    --argc;
    ++argv;
    if (argc == 0)
        carte(stdin);
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            carte(fp);
            fclose(fp);
            argv++;
        }
    }
    return (0);
}


void  carte(FILE *fp)
{
    char  buf[MAX_SIZE];

    while (fgets(buf, MAX_SIZE, fp) != NULL) {
        remove_pre_blank(buf);
        remove_pos_blank(buf);
        center(buf, WIDTH);
        fputs(buf, stdout);
    }
}


void  center(char buf[], int w)
{
    int   off;
    int   n;
    int   i;

    n = strlen(buf) - 1; /* -1 for '\n' */
    if (w < n)
        return;
    off = (w - n + 1) / 2; /* ٤ο */

    /* ޤˤ餷Ƥ */
    for (i = n + 1; i >= 0; i--)
        buf[i + off] = buf[i];

    /* ˶ */
    while (off--)
        buf[off] = ' ';
}


/* ζ */
void  remove_pre_blank(char *buf)
{
    int   n;
    char  *p;
    char  *q;

    for (p = buf; ISBLANK(*p); p++)
        ;
    q = buf;
    n = strlen(p) + 1;
    while (n--)
        *q++ = *p++;
}


/* ζ */
void  remove_pos_blank(char *buf)
{
    char  *q;

    if (*buf == '\0')
        return;
    q = buf + strlen(buf) - 1; /* 1\nʬ */
    while (q > buf && ISBLANK(*(q - 1)))
        --q;
    *q = '\n';
    *(q + 1) = '\0';
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
