/*
 * find1.c
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_SIZE  (80 + 1 + 1)  /* + +'\0' */


void  find(FILE *, char *);
void  usage(void);
void  cant(char *);


main(int argc, char **argv)
{
    char  *keyword;
    FILE  *fp;

    --argc;
    ++argv;
    if (argc < 1)
        usage(); /* no return */

    --argc;
    keyword  = *argv++;

    if (argc == 0)
        find(stdin, keyword);
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            find(fp, keyword);
            fclose(fp);
            argv++;
        }
    }
    return (0);
}


void  find(FILE *fp, char *word)
{
    char  buf[MAX_SIZE];

    while (fgets(buf, MAX_SIZE, fp) != NULL) {
        if (strstr(buf, word))   /* ĤäȤˤ0ʳ */
            fputs(buf, stdout);
    }
}


void  usage(void)
{
    fprintf(stderr, "Usage: file1 keyword [file ...]\n");
    exit(1);
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
