/*
 * findthe.c
 */
#include <stdio.h>
#include <string.h>

#define MAX_SIZE  (80 + 1 + 1)  /* + +'\0' */
#define KEYWORD   "the"


void  find(FILE *);
void  cant(char *);


main(int argc, char **argv)
{
    FILE    *fp;

    --argc;
    ++argv;
    if (argc == 0)
        find(stdin);
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            find(fp);
            fclose(fp);
            argv++;
        }
    }
    return (0);
}


void  find(FILE *fp)
{
    char  buf[MAX_SIZE];

    while (fgets(buf, MAX_SIZE, fp) != NULL) {
        if (strstr(buf, KEYWORD))
            fputs(buf, stdout);
    }
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
