/*
 * lcat.c
 */
#include <stdio.h>

#define MAX_SIZE  (80 + 1 + 1) /* + +'\0' */


void  cat(FILE *);
void  cant(char *);


main(int argc, char **argv)
{
    FILE    *fp;

    --argc;
    ++argv;
    if (argc == 0)
        cat(stdin);
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv); /* no return */
            cat(fp);
            fclose(fp);
            argv++;
        }
    }
    return (0);
}


void  cat(FILE *fp)
{
    char  buf[MAX_SIZE];

    while (fgets(buf, MAX_SIZE, fp) != NULL)
        fputs(buf, stdout);
}


void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
