/*
 * sort4.c - Ԥ
 */
#include <stdio.h>
#include <stdlib.h>

#define YES             1
#define NO              0
#define LINE_SIZE       (4096 + 2)
#define MAX_LINES       1000

char *strdup(const char *);
int   mycomp(const char **, const char **);
static void  sort(int);
static int   read_line(FILE *, int);
static void  write_line(FILE *, int);
static void  usage(void);
static void  cant(char *);
static void  error(char *);

int   r_flag = NO;      /* ߽ˤ뤫ɤ */
int   f_flag = NO;      /* ʸ/ʸ̤뤫ɤ */
static char  *line[MAX_LINES];


main(int argc, char **argv)
{
    FILE  *fp;
    char  *s;
    int   n;

    while (--argc > 0 && **++argv == '-') {
        for (s = *argv + 1; *s != '\0'; s++) {
            switch (*s) {
            case 'f':
                f_flag = YES;
                break;
            case 'r':
                r_flag = YES;
                break;
            default:
                usage();
            }
        }
    }

    n = 0;
    if (argc == 0) {
        n = read_line(stdin, 0);    /*  */
        sort(n);                    /*  */
        write_line(stdout, n);      /*  */
    }
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv);
            n += read_line(fp, n);  /*  */
            fclose(fp);
            argv++;
        }
        sort(n);                    /*  */
        write_line(stdout, n);      /*  */
    }
    return (0);
}


/* ǡɤ߹ǵ */
static int   read_line(FILE *fp, int m)
{
    char  tmp[LINE_SIZE];
    int   i;

    for (i = 0; fgets(tmp, LINE_SIZE, fp) != NULL; i++) {
        if (i + m < MAX_LINES) {
            if ((line[i + m] = strdup(tmp)) == NULL)
                error("can't alloc memory");
        }
        else
            error("too many lines");
    }
    return (i);
}


/* Υǡ */
static void  write_line(FILE *fp, int n)
{
    int   i;

    for (i = 0; i < n; i++) {
        fputs(line[i], fp);
        free(line[i]);
    }
}


/* ǡ */
static void  sort(int n)
{
    qsort(line, n, sizeof(char *), mycomp);
}


/* ޥɤɽƽλ */
static void  usage(void)
{
    fprintf(stderr, "Usage: sort4 [file ...]\n");
    exit(1);
}


/* fileopenǤʤɽƽλ */
static void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}


/* 顼åɽƽλ */
static void  error(char *str)
{
    fprintf(stderr, "%s\n", str);
    exit(1);
}
