/*
 * list.c - ꥹȹ¤Ѵؿ
 */
#include <stdio.h>
#include <stdlib.h>
#include "line.h"


LINE  list = {&list, &list, NULL};

#if MSC
#include <string.h>
#else
char  *strdup(char *);
#endif


/* ꥹȹ¤1ʬΥǡɲ */
LINE  *add_line(LINE *c, char *buf)
{
    LINE  *np;

    if ((np = (LINE *)malloc(sizeof(LINE))) == NULL)
        return (NULL);
    if ((np->buf = strdup(buf)) == NULL) {
        free(np);
        return (NULL);
    }
    np->prev = c;
    np->next = c->next;
    c->next->prev = np;
    c->next = np;
    return (np);
}


/* ƹѤ˳ݤ꡼򤹤٤Ʋ */
void  delete_all_lines(void)
{
    LINE    *cur;

    for (cur = list.next; cur != &list; cur = del_line(cur))
        ;
}


/* ꥹȹ¤1ʬΥǡ */
LINE  *del_line(LINE *c)
{
    LINE  *p;

    p = c->next;
    c->next->prev = c->prev;
    c->prev->next = c->next;
    free(c->buf);
    free(c);
    return (p);
}
