/*
 * sort2.c - Ԥ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LINE_SIZE       (256 + 2)   /* 1Ԥκʸ+'\n'+'\0' */
#define MAX_LINES       100         /* Կ */
#define YES             1
#define NO              0


void  sort(int);
int   read_line(FILE *, int);
void  write_line(FILE *, int);
int   mycomp(const char *, const char *);
void  usage(void);
void  cant(char *);

char  line[MAX_LINES][LINE_SIZE];
int   r_flag = NO;      /* ߽ˤ뤫ɤ */


main(int argc, char **argv)
{
    FILE  *fp;
    char  *s;
    int   n;

    while (--argc > 0 && **++argv == '-') {
        for (s = *argv + 1; *s != '\0'; s++) {
            switch (*s) {
            case 'r':
                r_flag = YES;
                break;
            default:
                usage();
            }
        }
    }

    n = 0;
    if (argc == 0) {
        n = read_line(stdin, 0);    /*  */
        sort(n);                    /*  */
        write_line(stdout, n);      /*  */
    }
    else {
        while (argc--) {
            if ((fp = fopen(*argv, "r")) == NULL)
                cant(*argv);
            n += read_line(fp, n);  /*  */
            fclose(fp);
            argv++;
        }
        sort(n);                    /*  */
        write_line(stdout, n);      /*  */
    }
    return (0);
}


/* ǡɤ߹ǵ */
int read_line(FILE *fp, int m)
{
    char tmp[LINE_SIZE];
    int  i;

    for (i = 0; fgets(tmp, LINE_SIZE, fp) != NULL; i++) {
        if (i + m < MAX_LINES)
            strcpy(line[i + m], tmp);
        else {
            fprintf(stderr, "too many lines\n");
            exit(1);  /* abnormal terminate */
        }
    }
    return (i);
}


/* Υǡ */
void write_line(FILE *fp, int n)
{
    int  i;

    for (i = 0; i < n; i++)
        fputs(line[i], fp);
}


/* ǡ */
void  sort(int n)
{
    qsort(line, n, LINE_SIZE, mycomp);
}


/* 2ĤǤѴؿ */
int   mycomp(const char *a, const char *b)
{
    if (r_flag == NO)
        return (strcmp(a, b));  /*  */
    else
        return (strcmp(b, a));  /* ߽ */
}


/* ޥɤɽƽλ */
void  usage(void)
{
    fprintf(stderr, "Usage: sort2 [file ...]\n");
    exit(1);
}


/* fileopenǤʤäȤɽƽλ */
void  cant(char *name)
{
    fprintf(stderr, "can't open %s\n", name);
    exit(1);
}
